VERSION 5.00
Begin VB.Form frmDriveProperties 
   Caption         =   "Drive Properties"
   ClientHeight    =   2850
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4125
   Icon            =   "DriveProperties.frx":0000
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2850
   ScaleWidth      =   4125
   StartUpPosition =   3  'Windows Default
   Begin VB.ListBox List1 
      BackColor       =   &H00FFFFFF&
      Height          =   2790
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   4065
   End
End
Attribute VB_Name = "frmDriveProperties"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Public Sub GetDriveProperties(sDrive As String)
 
Dim fso As New FileSystemObject
Dim d As Drive

Me.Caption = "Drive Properties For Drive " & sDrive
Me.Show vbModal

List1.Clear

MousePointer = vbHourglass
Set d = fso.Drives(sDrive)
   
  ' Make sure the drive is ready and obtain the properties
  '
  If d.IsReady Then
    List1.AddItem "Drive : " & d.DriveLetter
    List1.AddItem "Serial #: " & d.SerialNumber
    List1.AddItem "Drive Volume " & d.VolumeName
    List1.AddItem "Share Name: " & d.ShareName
    List1.AddItem "Root Folder: " & d.RootFolder
    List1.AddItem "Path: " & d.Path
    List1.AddItem "File System: " & d.FileSystem
    List1.AddItem "Drive Type: " & GetDriveType(d.DriveType)
    List1.AddItem "Total Drive Space: " & Format(d.TotalSize, "#,###,###,##0") & " bytes"
    List1.AddItem "Availabe Drive Space: " & Format(d.AvailableSpace, "#,###,###,##0") & " bytes"
  Else
    List1.AddItem "Drive Not Ready"
  End If
 

MousePointer = vbDefault

End Sub

Private Function GetDriveType(nType As Integer) As String

Select Case nType
  Case 0
    GetDriveType = "Unknown"
  Case 1
    GetDriveType = "Removable"
  Case 2
    GetDriveType = "Fixed"
  Case 3
    GetDriveType = "Remote"
  Case 4
    GetDriveType = "CD-Rom"
  Case 5
    GetDriveType = "Ram Disk"
End Select
End Function

Private Sub Form_Load()
Me.Left = (Screen.Width - Me.ScaleWidth) / 2
Me.Top = (Screen.Height - Me.ScaleHeight) / 2
End Sub
