Attribute VB_Name = "Module1"
Option Explicit

Public Enum PortTypes
  PORT_TYPE_WRITE = &H1
  PORT_TYPE_READ = &H2
  PORT_TYPE_REDIRECTED = &H4
  PORT_TYPE_NET_ATTACHED = &H8
End Enum

Public Type PORT_INFO_2
  pPortName    As Long
  pMonitorName As Long
  pDescription As Long
  fPortType    As Long
  Reserved     As Long
End Type
  
'SIZEOFxxx is a non-windows constant defined for this method
Public Const SIZEOFPORT_INFO_2 = 20
Public Const LB_SETTABSTOPS As Long = &H192

  'EnumPorts member descriptions:
'pName: String specifying the name of the server whose
'printer ports you wish to enumerate. If pName is
'vbNullString, the function enumerates the local
'machine's printer ports.
 
'nLevel: Specifies the type of information returned in
'the lpbPorts buffer. If nLevel is 1, lpbPorts receives
'an array of PORT_INFO_1 structures. If nLevel is 2,
'lpbPorts receives an array of PORT_INFO_2 structures.

'lpbPorts: Pointer to a buffer that receives an array of
'PORT_INFO_1 or PORT_INFO_2 structures. Each structure
'contains data that describes an available printer port.
'The buffer must be large enough to store the strings
'pointed to by the structure members.

'cbBuf: the size, in bytes, of the buffer pointed to by lpbPorts.
 
'pcbNeeded: receives the number of bytes copied to the lpbPorts
'buffer. If the the buffer is too small, the function fails and
'the variable receives the number of bytes required.
 
'pcReturned: variable that receives the number of PORT_INFO_1 or
'PORT_INFO_2 structures returned in the pPorts buffer. This
'corresponds to the number of printer ports that are available
'on the specified machine.

Public Declare Function EnumPorts Lib "winspool.drv" _
   Alias "EnumPortsA" _
  (ByVal pName As String, _
   ByVal nLevel As Long, _
   lpbPorts As Any, _
   ByVal cbBuf As Long, _
   pcbNeeded As Long, _
   pcReturned As Long) As Long

Public Declare Function lstrlenA Lib "kernel32" _
   (lpString As Any) As Long

Public Declare Function lstrcpyA Lib "kernel32" _
   (lpString1 As Any, lpString2 As Any) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
  (ByVal hwnd As Long, _
   ByVal wMsg As Long, _
   ByVal wParam As Long, _
   lParam As Any) As Long


