VERSION 5.00
Begin VB.Form frmEdit 
   Caption         =   "Edit Text File"
   ClientHeight    =   4620
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6675
   Icon            =   "edit.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   4620
   ScaleWidth      =   6675
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Close"
      Height          =   375
      Left            =   5670
      TabIndex        =   2
      Top             =   4200
      Width           =   915
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   "&Save"
      Height          =   375
      Left            =   4740
      TabIndex        =   1
      Top             =   4200
      Width           =   915
   End
   Begin VB.TextBox txtEdit 
      Height          =   4155
      Left            =   30
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   0
      Width           =   6615
   End
End
Attribute VB_Name = "frmEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim fso As New FileSystemObject
Dim sFileName As String
Public Sub Createfile(sfile As String)
Dim ts As TextStream

On Error GoTo err_handler:

'Create the text file and close
'
Set ts = fso.CreateTextFile(sfile)
'ts.Write " "
ts.Close

sFileName = sfile
Me.Show vbModal

Exit Sub

err_handler:
  MsgBox Err.Number & " - " & Err.Description
  

End Sub
Public Sub OpenFile(sfile As String)
Dim ts As TextStream

' Open the File and assign a TextStream object to it
'
Set ts = fso.OpenTextFile(sfile)

' Read the entire file
' ** NOTE -  This may generate an error if not loading a text file. It will also
' only load the first 64K in the text box as that is the upper limit of a VB Text Box.
'

On Error GoTo Error_Exit

' Check to make sure it is not a 0 byte file
'
If Not ts.AtEndOfStream Then
  txtEdit = ts.ReadAll
End If

ts.Close
sFileName = sfile
Me.Show vbModal

Exit Sub

Error_Exit:
Unload Me


End Sub

Private Sub cmdCancel_Click()
  Unload Me
End Sub

Private Sub cmdSave_Click()
Dim ts As TextStream

' Open the same File and assign a writable TextStream Object
'
On Error GoTo err_handler:

Set ts = fso.OpenTextFile(sFileName, ForWriting, True)
' Write the contents of the text box
'
ts.Write txtEdit
ts.Close

Exit Sub

err_handler:
  MsgBox "Error - Unable to Save Changes to " & sFileName

End Sub

Private Sub Form_Load()
Me.Left = (Screen.Width - Me.ScaleWidth) / 2
Me.Top = (Screen.Height - Me.ScaleHeight) / 2

End Sub
